package com.fjhx.customer.handle;


import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.date.DateField;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson2.JSON;
import com.alibaba.fastjson2.JSONArray;
import com.alibaba.fastjson2.JSONObject;
import com.baomidou.dynamic.datasource.annotation.DSTransactional;
import com.baomidou.dynamic.datasource.toolkit.DynamicDataSourceContextHolder;
import com.fasterxml.jackson.databind.DeserializationFeature;
import com.fjhx.common.constant.SourceConstant;
import com.fjhx.customer.entity.xiaoman.dto.XiaomanCustomerSelectDto;
import com.fjhx.customer.entity.xiaoman.po.XiaomanConfig;
import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fjhx.customer.contants.XiaomanContant;
import com.fjhx.customer.entity.xiaoman.vo.*;
import com.fjhx.customer.service.xiaoman.XiaomanCustomerService;
import com.fjhx.tenant.entity.dict.dto.DictTenantDataSelectDto;
import com.fjhx.tenant.entity.dict.po.DictTenantData;
import com.fjhx.tenant.entity.dict.vo.DictTenantDataVo;
import com.fjhx.tenant.service.dict.DictTenantDataService;
import com.ruoyi.common.utils.SecurityUtils;
import com.ruoyi.common.utils.spring.SpringUtils;
import com.fjhx.customer.service.xiaoman.XiaomanConfigService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.data.redis.core.StringRedisTemplate;


import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import java.util.*;
import java.util.stream.Collectors;

@Slf4j
public class HandleXiaomanData {
    private static XiaomanConfigService xiaomanConfigService = SpringUtils.getBean(XiaomanConfigService.class);
    private static XiaomanCustomerService xiaomanCustomerService = SpringUtils.getBean(XiaomanCustomerService.class);
    private static StringRedisTemplate redisTemplate = SpringUtils.getBean(StringRedisTemplate.class);
    private static DictTenantDataService dictTenantDataService = SpringUtils.getBean(DictTenantDataService.class);

    public static void main(String[] args) {
        String filePath = "D:\\java_conding\\erhong\\hx-customer\\src\\main\\java\\com\\fjhx\\customer\\handle\\bbb.json";
        String jsonData = "";

        try (BufferedReader br = new BufferedReader(new FileReader(filePath))) {
            String line;
            while ((line = br.readLine()) != null) {
                jsonData += line;
            }
            handleDate(jsonData, new TypeReference<R<CustomerInfoVo>>() { });
//            handleAllCustomer(jsonData);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * 处理-小满用户
     * @param res
     * @param allCustomer
     * @return
     */
    public static CustomerListApiVo handleAllCustomer(String res,Set<Long> allCustomer){
        //反序列化对象
        CustomerListApiVo customerListApiVo = handleDate(res, new TypeReference<R<CustomerListApiVo>>() { });
        //判断列表是否为空
        if (!customerListApiVo.getList().isEmpty()){
            //保存或修改
            xiaomanCustomerService.handleSaveOrUpdate(customerListApiVo.getList(),allCustomer);
        }
        return customerListApiVo;
    }


    /**
     * 反序列化
     * @param res
     * @param typeReference
     * @param <T>
     * @return
     */
    public static <T> T handleDate(String res, TypeReference<R<T>> typeReference) {
        ObjectMapper objectMapper = new ObjectMapper();
        try {
            objectMapper.configure(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES, false);
            R<T> result = objectMapper.readValue(res, typeReference);
            if (result.isOk()) {
                return result.getData();
            }
            return null;
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }



    ///////////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////小满api接口////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////////





}
